diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.c freeciv-patched/server/ruleset.c
--- freeciv-cvs/server/ruleset.c	2003-07-07 18:20:27.000000000 +0100
+++ freeciv-patched/server/ruleset.c	2003-07-07 18:21:49.000000000 +0100
@@ -31,10 +31,12 @@
 #include "nation.h"
 #include "packets.h"
 #include "registry.h"
+#include "script.h"
 #include "shared.h"
 #include "support.h"
 #include "tech.h"
 #include "unit.h"
+#include "unittype.h"
 
 #include "citytools.h"
 
@@ -63,8 +65,8 @@
 static Impr_Type_id lookup_impr_type(struct section_file *file, const char *prefix,
 				     const char *entry, bool required,
 				     const char *filename, const char *description);
-static int lookup_government(struct section_file *file, const char *entry,
-			     const char *filename);
+static int lookup_government(struct section_file *file, const char *prefix,
+			     const char *entry, const char *filename);
 static int lookup_city_cost(struct section_file *file, const char *prefix,
 			    const char *entry, const char *filename);
 static char *lookup_helptext(struct section_file *file, char *prefix);
@@ -96,6 +98,10 @@
 
 static void send_ruleset_techs(struct conn_list *dest);
 static void send_ruleset_units(struct conn_list *dest);
+static void send_ruleset_unit_modifier_types(struct conn_list *dest);
+static void send_ruleset_unit_modifiers(struct conn_list *dest);
+static void send_ruleset_gov_modifier_types(struct conn_list *dest);
+static void send_ruleset_gov_modifiers(struct conn_list *dest);
 static void send_ruleset_buildings(struct conn_list *dest);
 static void send_ruleset_terrain(struct conn_list *dest);
 static void send_ruleset_governments(struct conn_list *dest);
@@ -347,13 +353,13 @@
   Lookup entry in the file and return the corresponding government index;
   dies if can't find/match.  filename is for error message.
 **************************************************************************/
-static int lookup_government(struct section_file *file, const char *entry,
-			     const char *filename)
+static int lookup_government(struct section_file *file, const char *prefix,
+			     const char *entry, const char *filename)
 {
   char *sval;
   struct government *gov;
   
-  sval = secfile_lookup_str(file, "%s", entry);
+  sval = secfile_lookup_str(file, "%s.%s", prefix, entry);
   gov = find_government_by_name(sval);
   if (!gov) {
     freelog(LOG_FATAL, "for %s couldn't match government \"%s\" (%s)",
@@ -784,6 +790,23 @@
       e->cond_bldg = B_LAST;
     }
 
+    item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_govmod",
+				      secname, j);
+    if (*item != '\0') {
+      int govmod = find_gov_modifier_by_name(item);
+      if (govmod < 0) {
+	freelog(LOG_ERROR, "for %s effect[%d].cond_govmod couldn't match "
+			   "government modifier \"%s\" (%s)",
+		name, j, item, filename);
+	e->cond_govmod = game.num_gov_modifiers;
+	problem = TRUE;
+      } else {
+	e->cond_govmod = govmod;
+      }
+    } else {
+      e->cond_govmod = game.num_gov_modifiers;
+    }
+
     item = secfile_lookup_str_default(file, "", "%s.effect%d.cond_gov",
 				      secname, j);
     if (*item != '\0') {
@@ -900,6 +923,92 @@
 /**************************************************************************
 ...  
 **************************************************************************/
+static void read_modifier_types(struct section_file *file,
+    				struct modifier_type *modifier_types,
+				int *num_modifier_types)
+{
+  char **sec;
+  int num_mods, i;
+  const char *filename = secfile_filename(file);
+
+  /* Read modifier types from mod_type_xxx entries */
+  sec = secfile_get_secnames_prefix(file, "mod_type_", &num_mods);
+  if (num_mods > MAX_MODS) {
+    freelog(LOG_FATAL, "Too many modifier types! (%d, max %d; %s)",
+	    num_mods, MAX_MODS, filename);
+    exit(EXIT_FAILURE);
+  }
+  *num_modifier_types = num_mods;
+
+  /* Read in names first so that lookup works later on */
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *um = &modifier_types[i];
+    sz_strlcpy(um->name, secfile_lookup_str(file, "%s.name", sec[i]));
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *um = &modifier_types[i];
+
+    um->id = modifier_type_from_str(um->name, modifier_types, num_mods);
+    um->tech_requirement = lookup_tech(file, sec[i], "tech_req", 0,
+				       filename, um->name);
+    um->obsoleted_by = lookup_unit_type(file, sec[i], "obsolete_by", 0,
+					filename, um->name);
+    um->must_use = secfile_lookup_bool(file, "%s.must_use", sec[i]);
+  }
+  free(sec);
+}
+
+/**************************************************************************
+...  
+**************************************************************************/
+static struct modifier *read_modifiers(struct section_file *file,
+    				       int *num_modifiers,
+				       struct modifier_type *modifier_types,
+				       int num_modifier_types)
+{
+  char **sec;
+  int num_mods, i;
+  struct modifier *modifiers;
+  const char *filename = secfile_filename(file);
+
+  sec = secfile_get_secnames_prefix(file, "modifier_", &num_mods);
+  if (num_mods > U_LAST) {
+    freelog(LOG_FATAL, "Too many unit modifiers (%d, max %d) in %s",
+	    num_mods, U_LAST, filename);
+    exit(EXIT_FAILURE);
+  }
+  *num_modifiers = num_mods;
+  if (num_mods) {
+    modifiers = fc_calloc(num_mods, sizeof(struct modifier));
+  } else {
+    modifiers = NULL;
+  }
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier *um = &modifiers[i];
+    char *str;
+
+    sz_strlcpy(um->name, secfile_lookup_str(file, "%s.name", sec[i]));
+    um->tech_requirement = lookup_tech(file, sec[i], "tech_req",
+				       FALSE, filename, um->name);
+    um->action = mystrdup(secfile_lookup_str(file, "%s.action", sec[i]));
+    um->final_action = mystrdup(secfile_lookup_str(file, "%s.final_action",
+						   sec[i]));
+    str = secfile_lookup_str(file, "%s.type", sec[i]);
+    if ((um->type = modifier_type_from_str(str, modifier_types, num_modifier_types)) == -1) {
+      freelog(LOG_FATAL, "Bad unit modifier type %s for \"%s\" (%s)", str,
+	      um->name, filename);
+      exit(EXIT_FAILURE);
+    }
+    um->effect = load_effects(sec[i], um->name, file, FALSE, TRUE);
+  }
+  free(sec);
+  return modifiers;
+}
+
+/**************************************************************************
+...  
+**************************************************************************/
 static void load_ruleset_units(struct section_file *file)
 {
   char *datafile_options;
@@ -911,6 +1020,8 @@
   datafile_options =
     check_ruleset_capabilities(file, "+1.9", filename);
 
+  read_modifier_types(file, unit_modifier_types, &game.num_unit_modifier_types);
+
   sec = secfile_get_secnames_prefix(file, "unit_", &nval);
 
   /* Tech requirement is used to flag removed unit_types, which
@@ -923,20 +1034,10 @@
 				      FALSE, filename, u->name);
   } unit_type_iterate_end;
 
-  unit_type_iterate(i) {
-    u = &unit_types[i];
-    if (unit_type_exists(i)) {
-      u->obsoleted_by = lookup_unit_type(file, sec[i],
-					 "obsolete_by", FALSE, filename, u->name);
-    } else {
-      (void) section_file_lookup(file, "%s.obsolete_by", sec[i]); /* unused */
-      u->obsoleted_by = -1;
-    }
-  } unit_type_iterate_end;
-
   /* main stats: */
   unit_type_iterate(i) {
     u = &unit_types[i];
+    u->basetype = U_LAST;
 
     u->impr_requirement =
       find_improvement_by_name(secfile_lookup_str_default(file, "None", 
@@ -1003,6 +1104,10 @@
     u->effect = load_effects(sec[i], u->name, file, TRUE, FALSE);
 
     u->helptext = lookup_helptext(file, sec[i]);
+    u->action = secfile_lookup_str_default(file, NULL, "%s.action",
+					   sec[i]);
+    u->final_action = secfile_lookup_str_default(file, NULL,
+						 "%s.final_action", sec[i]);
   } unit_type_iterate_end;
   
   /* flags */
@@ -1062,10 +1167,67 @@
     }
     free(slist);
   } unit_type_iterate_end;
+  free(sec);
 
   lookup_tech_list(file, "u_specials", "partisan_req",
 		   game.rtech.partisan_req, filename);
 
+  unit_modifiers = read_modifiers(file, &game.num_unit_modifiers,
+				  unit_modifier_types,
+				  game.num_unit_modifier_types);
+
+  sec = secfile_get_secnames_prefix(file, "compound_unit_", &nval);
+  for (i = 0; i < nval; ++i) {
+    int modifiers[MAX_MODS];
+    char *name, *sval;
+    Unit_Type_id basetype;
+
+    name = secfile_lookup_str(file, "%s.name", sec[i]);
+    basetype = lookup_unit_type(file, sec[i], "base", TRUE,
+				filename, name);
+    freelog(LOG_DEBUG, "Forming compound unit %s", name);
+
+    for (j = 0; j < game.num_unit_modifier_types; ++j) {
+      sval = secfile_lookup_str(file, "%s.modifiers,%d", sec[i], j);
+      if (!unit_modifier_types[j].must_use && sval[0] == '\0') {
+	modifiers[j] = U_LAST;
+      } else {
+	int ival = find_unit_modifier_by_name(sval);
+
+	if (ival == U_LAST) {
+	  freelog(LOG_FATAL,
+		  "for %s, couldn't match unit modifier \"%s\" (%s)",
+		  sec[i], sval, filename);
+	  exit(EXIT_FAILURE);
+	} else if (unit_modifiers[ival].type != unit_modifier_types[j].id) {
+	  freelog(LOG_FATAL, "for %s, unit modifier \"%s\" is not of "
+		  "required compound type %s (%s)",
+		  sec[i], sval, unit_modifier_types[j].name,
+		  filename);
+	  exit(EXIT_FAILURE);
+	} else {
+	  modifiers[j] = ival;
+	}
+      }
+    }
+    sval = secfile_lookup_str(file, "%s.action", sec[i]);
+    form_compound_unit(name, basetype, modifiers, sval);
+  }
+  free(sec);
+
+  sec = secfile_get_secnames_prefix(file, "unit_", &nval);
+  for (i = 0; i < nval; i++) {
+    u = &unit_types[i];
+    if (unit_type_exists(i)) {
+      u->obsoleted_by = lookup_unit_type(file, sec[i], "obsolete_by",
+					 FALSE, filename, u->name);
+    } else {
+      (void) section_file_lookup(file, "%s.obsolete_by", sec[i]); /* unused */
+      u->obsoleted_by = -1;
+    }
+  }
+  free(sec);
+
   /* Some more consistency checking: */
   unit_type_iterate(i) {
     if (unit_type_exists(i)) {
@@ -1170,7 +1332,6 @@
 
   update_simple_ai_types();
 
-  free(sec);
   section_file_check_unused(file, filename);
   section_file_free(file);
 }
@@ -1636,33 +1797,13 @@
 
   sec = secfile_get_secnames_prefix(file, "government_", &nval);
 
-  game.default_government
-    = lookup_government(file, "governments.default", filename);
-  
-  game.government_when_anarchy
-    = lookup_government(file, "governments.when_anarchy", filename);
-  
-  game.ai_goal_government
-    = lookup_government(file, "governments.ai_goal", filename);
-
-  freelog(LOG_DEBUG, "govs: def %d, anarchy %d, ai_goal %d",
-	  game.default_government, game.government_when_anarchy,
-	  game.ai_goal_government);
-  
-  /* Because player_init is called before rulesets are loaded we set
-   * all players governments here, if they have not been previously
-   * set (eg by loading game).
-   */
-  for(i=0; i<MAX_NUM_PLAYERS+MAX_NUM_BARBARIANS; i++) {
-    if (game.players[i].government == G_MAGIC) {
-      game.players[i].government = game.default_government;
-    }
-  }
+  read_modifier_types(file, gov_modifier_types, &game.num_gov_modifier_types);
 
   /* easy ones: */
   government_iterate(g) {
     int i = g->index;
     
+    g->basetype = G_MAGIC;
     g->required_tech
       = lookup_tech(file, sec[i], "tech_req", FALSE, filename, g->name);
     
@@ -1832,6 +1973,71 @@
     }
     freelog(LOG_DEBUG, "%s subgoal %d", g->name, g->subgoal);
   } government_iterate_end;
+  free(sec);
+
+  gov_modifiers = read_modifiers(file, &game.num_gov_modifiers,
+  				 gov_modifier_types,
+				 game.num_gov_modifier_types);
+
+  sec = secfile_get_secnames_prefix(file, "compound_government_", &nval);
+  for (i = 0; i < nval; ++i) {
+    int modifiers[MAX_MODS];
+    char *name, *sval;
+    int basetype;
+
+    name = secfile_lookup_str(file, "%s.name", sec[i]);
+    basetype = lookup_government(file, sec[i], "base", filename);
+    freelog(LOG_DEBUG, "Forming compound gov %s based on %d", name, basetype);
+
+    for (j = 0; j < game.num_gov_modifier_types; ++j) {
+      sval = secfile_lookup_str(file, "%s.modifiers,%d", sec[i], j);
+      if (!gov_modifier_types[j].must_use && sval[0] == '\0') {
+	modifiers[j] = -1;
+      } else {
+	int ival = find_gov_modifier_by_name(sval);
+
+	if (ival < 0) {
+	  freelog(LOG_FATAL,
+		  "for %s, couldn't match gov modifier \"%s\" (%s)",
+		  sec[i], sval, filename);
+	  exit(EXIT_FAILURE);
+	} else if (gov_modifiers[ival].type != gov_modifier_types[j].id) {
+	  freelog(LOG_FATAL, "for %s, gov modifier \"%s\" is not of "
+		  "required compound type %s (%s)",
+		  sec[i], sval, gov_modifier_types[j].name,
+		  filename);
+	  exit(EXIT_FAILURE);
+	} else {
+	  modifiers[j] = ival;
+	}
+      }
+    }
+    form_compound_gov(NULL, name, basetype, modifiers);
+  }
+  free(sec);
+
+  game.default_government
+    = lookup_government(file, "governments", "default", filename);
+  
+  game.government_when_anarchy
+    = lookup_government(file, "governments", "when_anarchy", filename);
+  
+  game.ai_goal_government
+    = lookup_government(file, "governments", "ai_goal", filename);
+
+  freelog(LOG_DEBUG, "govs: def %d, anarchy %d, ai_goal %d",
+	  game.default_government, game.government_when_anarchy,
+	  game.ai_goal_government);
+  
+  /* Because player_init is called before rulesets are loaded we set
+   * all players governments here, if they have not been previously
+   * set (eg by loading game).
+   */
+  for(i=0; i<MAX_NUM_PLAYERS+MAX_NUM_BARBARIANS; i++) {
+    if (game.players[i].government == G_MAGIC) {
+      game.players[i].government = game.default_government;
+    }
+  }
     
   /* ai tech_hints: */
   j = -1;
@@ -1868,7 +2074,6 @@
     ai_gov_tech_hints[j].tech = A_LAST;
   }
 
-  free(sec);
   section_file_check_unused(file, filename);
   section_file_free(file);
 }
@@ -1906,6 +2111,11 @@
   packet.num_impr_types = game.num_impr_types;
   packet.num_tech_types = game.num_tech_types;
 
+  packet.num_unit_modifier_types = game.num_unit_modifier_types;
+  packet.num_unit_modifiers = game.num_unit_modifiers;
+  packet.num_gov_modifier_types = game.num_gov_modifier_types;
+  packet.num_gov_modifiers = game.num_gov_modifiers;
+
   packet.nation_count = game.nation_count;
   packet.playable_nation_count = game.playable_nation_count;
   packet.style_count = game.styles_count;
@@ -2575,53 +2785,140 @@
   section_file_free(&file);
 }
 
+static void send_ruleset_modifier_types(struct conn_list *dest, bool is_gov)
+{
+  struct packet_ruleset_modifier_type packet;
+  int i, num_mods;
+  struct modifier_type *modifier_types;
+
+  if (is_gov) {
+    num_mods = game.num_gov_modifier_types;
+    modifier_types = gov_modifier_types;
+  } else {
+    num_mods = game.num_unit_modifier_types;
+    modifier_types = unit_modifier_types;
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier_type *u = &modifier_types[i];
+
+    packet.id = i;
+    packet.is_gov = is_gov;
+    packet.basetype = u->id;
+    sz_strlcpy(packet.name, u->name);
+    packet.tech_requirement = u->tech_requirement;
+    packet.must_use = u->must_use;
+    lsend_packet_ruleset_modifier_type(dest, &packet);
+  }
+}
+
+static void send_ruleset_unit_modifier_types(struct conn_list *dest)
+{
+  send_ruleset_modifier_types(dest, FALSE);
+}
+
+static void send_ruleset_gov_modifier_types(struct conn_list *dest)
+{
+  send_ruleset_modifier_types(dest, TRUE);
+}
+
+static void send_ruleset_modifiers(struct conn_list *dest, bool is_gov)
+{
+  struct packet_ruleset_modifier packet;
+  int i, num_mods;
+  struct modifier *modifiers;
+
+  if (is_gov) {
+    num_mods = game.num_gov_modifiers;
+    modifiers = gov_modifiers;
+  } else {
+    num_mods = game.num_unit_modifiers;
+    modifiers = unit_modifiers;
+  }
+
+  for (i = 0; i < num_mods; ++i) {
+    struct modifier *u = &modifiers[i];
+
+    packet.id = i;
+    packet.is_gov = is_gov;
+    sz_strlcpy(packet.name, u->name);
+    packet.type = u->type;
+    packet.tech_requirement = u->tech_requirement;
+    packet.effect = u->effect;       /* pointer assignment */
+    lsend_packet_ruleset_modifier(dest, &packet);
+  }
+}
+
+static void send_ruleset_unit_modifiers(struct conn_list *dest)
+{
+  send_ruleset_modifiers(dest, FALSE);
+}
+
+static void send_ruleset_gov_modifiers(struct conn_list *dest)
+{
+  send_ruleset_modifiers(dest, TRUE);
+}
+
 /**************************************************************************
   Send the units ruleset information (all individual units) to the
   specified connections.
 **************************************************************************/
 static void send_ruleset_units(struct conn_list *dest)
 {
-  struct packet_ruleset_unit packet;
-
   unit_type_iterate(utype_id) {
-    struct unit_type *u = get_unit_type(utype_id);
+    send_single_unit(dest, utype_id);
+  } unit_type_iterate_end;
+}
 
-    packet.id = u-unit_types;
-    sz_strlcpy(packet.name, u->name_orig);
-    sz_strlcpy(packet.sound_move, u->sound_move);
-    sz_strlcpy(packet.sound_move_alt, u->sound_move_alt);
-    sz_strlcpy(packet.sound_fight, u->sound_fight);
-    sz_strlcpy(packet.sound_fight_alt, u->sound_fight_alt);
-    sz_strlcpy(packet.graphic_str, u->graphic_str);
-    sz_strlcpy(packet.graphic_alt, u->graphic_alt);
-    packet.move_type = u->move_type;
-    packet.build_cost = u->build_cost;
-    packet.pop_cost = u->pop_cost;
-    packet.attack_strength = u->attack_strength;
-    packet.defense_strength = u->defense_strength;
-    packet.move_rate = u->move_rate;
-    packet.tech_requirement = u->tech_requirement;
-    packet.impr_requirement = u->impr_requirement;
-    packet.vision_range = u->vision_range;
-    packet.transport_capacity = u->transport_capacity;
-    packet.hp = u->hp;
-    packet.firepower = u->firepower;
-    packet.obsoleted_by = u->obsoleted_by;
-    packet.fuel = u->fuel;
-    packet.flags = u->flags;
-    packet.roles = u->roles;
-    packet.happy_cost = u->happy_cost;
-    packet.shield_cost = u->shield_cost;
-    packet.food_cost = u->food_cost;
-    packet.gold_cost = u->gold_cost;
-    packet.paratroopers_range = u->paratroopers_range;
-    packet.paratroopers_mr_req = u->paratroopers_mr_req;
-    packet.paratroopers_mr_sub = u->paratroopers_mr_sub;
-    packet.effect = u->effect;       /* pointer assignment */
-    packet.helptext = u->helptext;   /* pointer assignment */
+/**************************************************************************
+  Sends a single unit type to the player, to allow individual unit types
+  to be resent later during the game if the details change
+**************************************************************************/
+void send_single_unit(struct conn_list *dest, Unit_Type_id utype_id)
+{
+  struct packet_ruleset_unit packet;
+  struct unit_type *u = get_unit_type(utype_id);
+  int i;
 
-    lsend_packet_ruleset_unit(dest, &packet);
-  } unit_type_iterate_end;
+  packet.id = u-unit_types;
+  sz_strlcpy(packet.name, u->name_orig);
+  sz_strlcpy(packet.sound_move, u->sound_move);
+  sz_strlcpy(packet.sound_move_alt, u->sound_move_alt);
+  sz_strlcpy(packet.sound_fight, u->sound_fight);
+  sz_strlcpy(packet.sound_fight_alt, u->sound_fight_alt);
+  sz_strlcpy(packet.graphic_str, u->graphic_str);
+  sz_strlcpy(packet.graphic_alt, u->graphic_alt);
+  packet.move_type = u->move_type;
+  packet.build_cost = u->build_cost;
+  packet.pop_cost = u->pop_cost;
+  packet.attack_strength = u->attack_strength;
+  packet.defense_strength = u->defense_strength;
+  packet.move_rate = u->move_rate;
+  packet.tech_requirement = u->tech_requirement;
+  packet.impr_requirement = u->impr_requirement;
+  packet.vision_range = u->vision_range;
+  packet.transport_capacity = u->transport_capacity;
+  packet.hp = u->hp;
+  packet.firepower = u->firepower;
+  packet.obsoleted_by = u->obsoleted_by;
+  packet.fuel = u->fuel;
+  packet.flags = u->flags;
+  packet.roles = u->roles;
+  packet.happy_cost = u->happy_cost;
+  packet.shield_cost = u->shield_cost;
+  packet.food_cost = u->food_cost;
+  packet.gold_cost = u->gold_cost;
+  packet.paratroopers_range = u->paratroopers_range;
+  packet.paratroopers_mr_req = u->paratroopers_mr_req;
+  packet.paratroopers_mr_sub = u->paratroopers_mr_sub;
+  packet.basetype = u->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    packet.modifiers[i] = u->modifiers[i];
+  }
+  packet.effect = u->effect;       /* pointer assignment */
+  packet.helptext = u->helptext;   /* pointer assignment */
+
+  lsend_packet_ruleset_unit(dest, &packet);
 }
 
 /**************************************************************************
@@ -2756,90 +3053,110 @@
 **************************************************************************/
 static void send_ruleset_governments(struct conn_list *dest)
 {
+  int i;
+
+  for (i = 0; i < game.government_count; ++i) {
+    send_single_government(dest, i);
+  }
+}
+
+/**************************************************************************
+  Send a single government type to the connections - this allows portions
+  of the government ruleset to be resent to the clients as they change
+  during the course of the game.
+**************************************************************************/
+void send_single_government(struct conn_list *dest, int id)
+{
   struct packet_ruleset_government gov;
   struct packet_ruleset_government_ruler_title title;
   struct ruler_title *p_title;
-  int j;
+  struct government *g;
+  int i;
 
-  government_iterate(g) {
-    /* send one packet_government */
-    gov.id                 = g->index;
+  g = &governments[id];
+
+  /* send one packet_government */
+  gov.id                 = g->index;
 
-    gov.required_tech    = g->required_tech;
-    gov.max_rate         = g->max_rate;
-    gov.civil_war        = g->civil_war;
-    gov.martial_law_max  = g->martial_law_max;
-    gov.martial_law_per  = g->martial_law_per;
-    gov.empire_size_mod  = g->empire_size_mod;
-    gov.empire_size_inc  = g->empire_size_inc;
-    gov.rapture_size     = g->rapture_size;
-    
-    gov.unit_happy_cost_factor  = g->unit_happy_cost_factor;
-    gov.unit_shield_cost_factor = g->unit_shield_cost_factor;
-    gov.unit_food_cost_factor   = g->unit_food_cost_factor;
-    gov.unit_gold_cost_factor   = g->unit_gold_cost_factor;
-    
-    gov.free_happy  = g->free_happy;
-    gov.free_shield = g->free_shield;
-    gov.free_food   = g->free_food;
-    gov.free_gold   = g->free_gold;
-
-    gov.trade_before_penalty = g->trade_before_penalty;
-    gov.shields_before_penalty = g->shields_before_penalty;
-    gov.food_before_penalty = g->food_before_penalty;
-
-    gov.celeb_trade_before_penalty = g->celeb_trade_before_penalty;
-    gov.celeb_shields_before_penalty = g->celeb_shields_before_penalty;
-    gov.celeb_food_before_penalty = g->celeb_food_before_penalty;
-
-    gov.trade_bonus = g->trade_bonus;
-    gov.shield_bonus = g->shield_bonus;
-    gov.food_bonus = g->food_bonus;
-
-    gov.celeb_trade_bonus = g->celeb_trade_bonus;
-    gov.celeb_shield_bonus = g->celeb_shield_bonus;
-    gov.celeb_food_bonus = g->celeb_food_bonus;
-
-    gov.corruption_level = g->corruption_level;
-    gov.corruption_modifier = g->corruption_modifier;
-    gov.fixed_corruption_distance = g->fixed_corruption_distance;
-    gov.corruption_distance_factor = g->corruption_distance_factor;
-    gov.extra_corruption_distance = g->extra_corruption_distance;
-    gov.corruption_max_distance_cap = g->corruption_max_distance_cap;
-    
-    gov.waste_level = g->waste_level;
-    gov.waste_modifier = g->waste_modifier;
-    gov.fixed_waste_distance = g->fixed_waste_distance;
-    gov.waste_distance_factor = g->waste_distance_factor;
-    gov.extra_waste_distance = g->extra_waste_distance;
-    gov.waste_max_distance_cap = g->waste_max_distance_cap;
+  gov.required_tech    = g->required_tech;
+  gov.max_rate         = g->max_rate;
+  gov.civil_war        = g->civil_war;
+  gov.martial_law_max  = g->martial_law_max;
+  gov.martial_law_per  = g->martial_law_per;
+  gov.empire_size_mod  = g->empire_size_mod;
+  gov.empire_size_inc  = g->empire_size_inc;
+  gov.rapture_size     = g->rapture_size;
+
+  gov.basetype         = g->basetype;
+  for (i = 0; i < MAX_MODS; ++i) {
+    gov.modifiers[i]   = g->modifiers[i];
+  }
+    
+  gov.unit_happy_cost_factor  = g->unit_happy_cost_factor;
+  gov.unit_shield_cost_factor = g->unit_shield_cost_factor;
+  gov.unit_food_cost_factor   = g->unit_food_cost_factor;
+  gov.unit_gold_cost_factor   = g->unit_gold_cost_factor;
+    
+  gov.free_happy  = g->free_happy;
+  gov.free_shield = g->free_shield;
+  gov.free_food   = g->free_food;
+  gov.free_gold   = g->free_gold;
+
+  gov.trade_before_penalty = g->trade_before_penalty;
+  gov.shields_before_penalty = g->shields_before_penalty;
+  gov.food_before_penalty = g->food_before_penalty;
+
+  gov.celeb_trade_before_penalty = g->celeb_trade_before_penalty;
+  gov.celeb_shields_before_penalty = g->celeb_shields_before_penalty;
+  gov.celeb_food_before_penalty = g->celeb_food_before_penalty;
+
+  gov.trade_bonus = g->trade_bonus;
+  gov.shield_bonus = g->shield_bonus;
+  gov.food_bonus = g->food_bonus;
+
+  gov.celeb_trade_bonus = g->celeb_trade_bonus;
+  gov.celeb_shield_bonus = g->celeb_shield_bonus;
+  gov.celeb_food_bonus = g->celeb_food_bonus;
+
+  gov.corruption_level = g->corruption_level;
+  gov.corruption_modifier = g->corruption_modifier;
+  gov.fixed_corruption_distance = g->fixed_corruption_distance;
+  gov.corruption_distance_factor = g->corruption_distance_factor;
+  gov.extra_corruption_distance = g->extra_corruption_distance;
+  gov.corruption_max_distance_cap = g->corruption_max_distance_cap;
+    
+  gov.waste_level = g->waste_level;
+  gov.waste_modifier = g->waste_modifier;
+  gov.fixed_waste_distance = g->fixed_waste_distance;
+  gov.waste_distance_factor = g->waste_distance_factor;
+  gov.extra_waste_distance = g->extra_waste_distance;
+  gov.waste_max_distance_cap = g->waste_max_distance_cap;
         
-    gov.flags = g->flags;
-    gov.hints = g->hints;
-    gov.num_ruler_titles = g->num_ruler_titles;
-
-    sz_strlcpy(gov.name, g->name_orig);
-    sz_strlcpy(gov.graphic_str, g->graphic_str);
-    sz_strlcpy(gov.graphic_alt, g->graphic_alt);
+  gov.flags = g->flags;
+  gov.hints = g->hints;
+  gov.num_ruler_titles = g->num_ruler_titles;
+
+  sz_strlcpy(gov.name, g->name_orig);
+  sz_strlcpy(gov.graphic_str, g->graphic_str);
+  sz_strlcpy(gov.graphic_alt, g->graphic_alt);
     
-    gov.effect = g->effect;       /* pointer assignment */
-    gov.helptext = g->helptext;   /* pointer assignment */
+  gov.effect = g->effect;       /* pointer assignment */
+  gov.helptext = g->helptext;   /* pointer assignment */
       
-    lsend_packet_ruleset_government(dest, &gov);
-    
-    /* send one packet_government_ruler_title per ruler title */
-    for(j=0; j<g->num_ruler_titles; j++) {
-      p_title = &g->ruler_titles[j];
-
-      title.gov = g->index;
-      title.id = j;
-      title.nation = p_title->nation;
-      sz_strlcpy(title.male_title, p_title->male_title);
-      sz_strlcpy(title.female_title, p_title->female_title);
+  lsend_packet_ruleset_government(dest, &gov);
     
-      lsend_packet_ruleset_government_ruler_title(dest, &title);
-    }
-  } government_iterate_end;
+  /* send one packet_government_ruler_title per ruler title */
+  for(i = 0; i < g->num_ruler_titles; i++) {
+    p_title = &g->ruler_titles[i];
+
+    title.gov = id;
+    title.id = i;
+    title.nation = p_title->nation;
+    sz_strlcpy(title.male_title, p_title->male_title);
+    sz_strlcpy(title.female_title, p_title->female_title);
+  
+    lsend_packet_ruleset_government_ruler_title(dest, &title);
+  }
 }
 
 /**************************************************************************
@@ -2944,6 +3261,8 @@
 
   freelog(LOG_NORMAL, _("Loading rulesets"));
 
+  script_load_library();
+
   openload_ruleset_file(&techfile, "techs");
   load_tech_names(&techfile);
 
@@ -2988,7 +3307,11 @@
   send_ruleset_game(dest);
   send_ruleset_techs(dest);
   send_ruleset_governments(dest);
+  send_ruleset_gov_modifier_types(dest);
+  send_ruleset_gov_modifiers(dest);
   send_ruleset_units(dest);
+  send_ruleset_unit_modifier_types(dest);
+  send_ruleset_unit_modifiers(dest);
   send_ruleset_terrain(dest);
   send_ruleset_buildings(dest);
   send_ruleset_nations(dest);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/server/ruleset.h freeciv-patched/server/ruleset.h
--- freeciv-cvs/server/ruleset.h	2003-01-03 16:09:50.000000000 +0000
+++ freeciv-patched/server/ruleset.h	2003-07-07 18:21:49.000000000 +0100
@@ -13,9 +13,14 @@
 #ifndef FC__RULESET_H
 #define FC__RULESET_H
 
+#include "unittype.h"
+
 struct conn_list;
 
 void load_rulesets(void);
 void send_rulesets(struct conn_list *dest);
 
+void send_single_unit(struct conn_list *dest, Unit_Type_id utype_id);
+void send_single_government(struct conn_list *dest, int id);
+
 #endif  /* FC__RULESET_H */
